﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
  using System;

  using HeuristicLab.Algorithms.PushGP.Data.Pool;

  public class PushGpInterpreterPool {
    private readonly ObjectPool<PooledPushGpInterpreter> pool;

    public PushGpInterpreterPool(Configuration config = null)
      : this(Environment.ProcessorCount * 2, config) {
    }

    public PushGpInterpreterPool(int size, Configuration config = null) {
      Configuration = config ?? new Configuration();

      pool = new ObjectPool<PooledPushGpInterpreter>(() => new PooledPushGpInterpreter(this, Configuration), size);
    }

    public Configuration Configuration { get; private set; }

    public PooledPushGpInterpreter GetInstance() {
      return pool.Allocate();
    }

    public void Free(PooledPushGpInterpreter interpreter) {
      pool.Free(interpreter);
    }
  }
}
