﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public class ReplaceSpaceWithNewlinePushData : Data<string, string[]>, IPushData {
    public ReplaceSpaceWithNewlinePushData(Example<string, string[]>[] training, Example<string, string[]>[] test)
      : base(training, test, 0, 128 * 70) {
    }

    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
      var asciiValues = GetAsciiValues(this.Training[index].Input);
      interpreter.IntegerStack.Push(asciiValues);
    }

    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
      var asciiValues = GetAsciiValues(this.Training[index].Input);
      interpreter.IntegerStack.Push(asciiValues);
    }

    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Training,
        data =>
          GetIntResultDifference(int.Parse(data[1]), interpreter.IntegerStack) +
          data[0].CompareTo(interpreter.NameStack.Top)
        );
    }

    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.IntegerStack,
        index,
        this.Test,
        data =>
          GetIntResultDifference(int.Parse(data[1]), interpreter.IntegerStack) +
          data[0].CompareTo(interpreter.NameStack.Top)
        );
    }
  }
}
